Modplayer
=========

Usage
-----
- when running via emulator, increase the audio buffers by starting it with:

  **x16emu -abufs 32**
- LOAD "MODPLAYER.PRG"
- RUN
- type file name, e.g. "D1.MOD" (you can change or correct it by using the "del" key)
- press "enter"
- enjoy!

Features
--------
- supports standard 4 channel mod files
- supports mod files with size up to 504 KB or higher depending on CX16 memory configuration
- user interface shows each channel with tone, instrument number and effect
- mod file name can be set via keyboard

Known issues and limitations
----------------------------
- sample rate is set to about 18 kHz, 8 bit, stereo to fix timing issues with channel mixer
- volume is reduced by half to avoid clipping
- no finetune for instruments
- only supported effects are: "slide up/down", "set volume", "pattern break" and "set speed"
- "set speed" effect doesn't support BPM setting
- player speed can be slightly off as it is based on 60 Hz vsync signal wheras many mod files are based on 50 Hz PAL signal
- first 2 letters of song name are missing due to the way how the kernal load routine is implemented
- no control unit yet


License
-------
Some sample mod files from different composers are included with this application.
All included mod files were downloaded from [The Mod Archive](https://modarchive.org) and are licensed under Public Domain or Creative Commons.
The original file names were changed to work around file name problems.

List of included mod files and its original file names:

### D1.mod
source: [songerson_-_dog39.mod](https://api.modarchive.org/downloads.php?moduleid=189675#songerson_-_dog39.mod) by [Songerson](https://modarchive.org/member.php?90970) is licensed under [CC BY 3.0](https://creativecommons.org/licenses/by/3.0/)

### D2.mod
source: [musix-retrospective.mod](https://api.modarchive.org/downloads.php?moduleid=65133#musix-retrospective.mod) by [m0d](https://modarchive.org/member.php?69141) is licensed under Public Domain

### D3.mod
source: [music-jump.mod](  https://api.modarchive.org/downloads.php?moduleid=53213#music-jump.mod) by [m0d](https://modarchive.org/member.php?69141) is licensed under Public Domain

### D4.mod
source: [evil_minded.mod](https://api.modarchive.org/downloads.php?moduleid=170000#evil_minded.mod) by [Zilly Mike](https://modarchive.org/member.php?69027) is licensed under [CC BY 3.0](https://creativecommons.org/licenses/by/3.0/)
